/**
 * Checks if value is a url
 * @param {string} value url string
 */
function isUrl (value) {
  if (!value) {
    return false;
  }

  try {
    var url = new URL(value);
    return true;
  } catch (error) {
    return false;
  }
};

/**
 * Overrides global window.open method to catch a url and send it to the SDK
 * @param {*} win window object
 */
function setupWindowOpenListener (win) {
  var winOpen = win.open;
  win.open = function () {
    var args = Array.from(arguments);
    var wn = winOpen.apply(win, args);
    var url = args[0];
    var fullUrl = url;

    if (isUrl(url)) {
      fullUrl = url;
    } else {
      fullUrl = win.location.origin + url;
    }

    ButtonSdk.onWindowOpen(fullUrl);

    return wn;
  };
};

setupWindowOpenListener(window);
